Subject: Re: [PATCH] tcp: /proc/net/tcp rto,ato values not scaled properly

From: Stephen Hemminger <[email-masked]>
Date: Fri, 20 Jun 2008 12:31:12 -0700

On Fri, 20 Jun 2008 12:05:26 -0700 (PDT)
David Miller <[email-masked]> wrote:

> From: Stephen Hemminger <[email-masked]>
> Date: Fri, 20 Jun 2008 11:56:03 -0700
> 
> > I found another case where we are sending information to userspace
> > in the wrong HZ scale.  This should have been fixed back in 2.5 :-(
> > 
> > This means an ABI change but as it stands there is no way for an application
> > like ss to get the right value.
> > 
> > Signed-off-by: Stephen Hemminger <[email-masked]>
> 
> Agree with your patch, but 'ss' should be getting this kind of info
> from netlink not procfs, right?
> 

Yes, ss tries netlink first and fallsback to /proc.

I am in process of making sure all usages of HZ in iproute utilities
are correct.  The old user code assumed that the hz value used by tc (psched)
was also correct for lots of other places. That is where I keep finding
these turds.

Soon all uses of get_hz() in iproute will be replaced with 
either get_psched_hz() for tc; get_user_hz for clock
values, or just use ms or us.